#include inkey.h
#include achoice.h

******************************************************************************
******************************************************************************
****************    YOU MAY ALTER THE #defines BELOW  ************************
******************************************************************************
******************************************************************************

*
* FORE_COL_MIN is the MIN value for COLUMN position of the FOREGROUND pointer.
* BACK_ROW_MIN is the MIN value for ROW    position of the BACKGROUND pointer.
*

#define FORE_COL_MIN  9
#define BACK_ROW_MIN 13

*
* These four constants represent the coordinates of the SAMPLE WINDOW.
*

#define SAMP_ULR  6
#define SAMP_ULC 41
#define SAMP_LRR 10
#define SAMP_LRC 69

*
* These four constants represent the coordinates of the ACHOICE MENU.
*

#define MENU_ULR  2
#define MENU_ULC  9
#define MENU_LRR 10
#define MENU_LRC 34

*
* This is the title and where it will go...
*

#define TITLE     EXPAND("CHANGE COLOR")
#define TITLE_ROW 3
#define TITLE_COL (80 - MENU_LRC - LEN(TITLE)) / 2 + MENU_LRC

******************************************************************************
******************************************************************************
****************      LEAVE THE REST THE FUCK ALONE!      ********************
******************************************************************************
******************************************************************************

*
* FORE_COL_MAX is the MAX value for COLUMN position of the FOREGROUND pointer.
* BACK_ROW_MAX is the MAX value for ROW    position of the BACKGROUND pointer.
*

#define FORE_COL_MAX FORE_COL_MIN + 60
#define BACK_ROW_MAX BACK_ROW_MIN + 7

*
* FORE_ROW is the value of the ROW    position of the FOREGROUND pointer.
* BACK_COL is the value of the COLUMN position of the BACKGROUND pointer.
*

#define FORE_ROW BACK_ROW_MIN - 1
#define BACK_COL FORE_COL_MAX + 4

*
* These values are the decimal ASCII values of the characters used as
*  foreground and background arrow pointers.
*

#define UP_ARROW    CHR(24)
#define DOWN_ARROW  CHR(25)
#define RIGHT_ARROW CHR(26)
#define LEFT_ARROW  CHR(27)

*
* These two macros are used mainly for readability.  They strip off the
*  standard and enhanced portions of the Clipper color string passed.
*

#define STANDARD(_c_) SUBSTR(_c_, 1, AT(",", _c_) - 1)
#define ENHANCED(_c_) SUBSTR(_c_,    AT("/", _c_) + 1)

*
* The rest are part of my 'standard' header file for all apps...
*

#define CENTER(_x, _y) INT((_y - LEN(_x)) / 2)
#define KEYPRESS(_k) KEYBOARD CHR(_k)
#define LSTR(_z) LTRIM(STR(_z, 0))

#define BACK(_a_) INT(_a_ / 16)
#define FORE(_a_) _a_ % 16

******************************************************************************
******************************************************************************
**********************  END OF PREPROCESSOR SCHTUFFF  ************************
******************************************************************************
******************************************************************************

