/***
*	Descend
*
*	C function to "complement" a string, date, number or logical "value"
*/

#include "extend.h"

extern int *_tos;
extern char *_str_all();
extern int _str_rel();

void descend()

{
	char *str;
	char *new_str;
	char *temp;
	unsigned str_len;

	/*	Treat MEMO and CHARACTER types identically */
	switch (_parinfo(1))
	{
		case CHARACTER:
		case MEMO:
			/*	Get the pointer to the string */
			str = _parc(1);

			/*	Get string length */
			str_len = strlen(str)+1;

			/*	Allocate new string space */
			new_str = (char *)_str_all(str_len);
			temp = new_str;

			/*	Invert character bytes while copying */
			while (*str)
			{
				*temp = (char)(256 - *str);
				str++;
				temp++;
			}
			/*	transfer null byte */
			temp = '\0';

			/*	Return the translated string */
			_retc(new_str);

			/*	Release work string */
			_str_rel(new_str, str_len);

			break;


		case DATE: 
			/*	5231808 is the result of adding the numeric values of the
				maximum and minimum dates  (12/31/2999) + (01/01/1900) */

			_retnd((double)5231808.0 - _parnd(1));

			/*	Fudge data type */
			*_tos = DATE;
			break;
		
		case LOGICAL: 
			_retl(!(_parl(1)));
			break;

		case NUMERIC: 
			/*	Get the numeric value and rotate around 0 */
			_retnd(-(_parnd(1)));
			break;
	}

	return;
}
