**	Demo program for functions in ERIN.PRG
**
**	Written by Joel Hassell
**
**	To create this demo, if you have Rettig's library:
**
**		CLIPPER ERINDEMO
**		PLINK86 FI ERINDEMO,ERIN,SOFF5,PUTWIN,GETWIN,VID_MOVE LIB TR86,CLIPPER
**
**	To create this demo, if you DON'T have Rettig's library:
**
**		Edit ERIN.PRG and follow the directions in the first part of the
**		program for modifying it to run withour Rettig's library.  Then,
**
**		CLIPPER ERIN
**		CLIPPER ERINDEMO
**		PLINK86 FI ERINDEMO,ERIN,SOFF5,PUTWIN,GETWIN,VID_MOVE LIB CLIPPER
**

header()
set color to W+/N
@ 5,10 say [countstr("A","ABC")]
@ 7,10 say [countstr("AA","AAAA")]
@ 9,10 say [countstr("A","AAAA")]
@11,10 say [countstr("A","BBBB")]
set color to W/N
@ 5,40 say countstr("A","ABC")		picture "99"
@ 7,40 say countstr("AA","AAAA")	picture "99"
@ 9,40 say countstr("A","AAAA")		picture "99"
@11,40 say countstr("A","BBBB")		picture "99"
stop()

clear
set color to W+/N
@ 5,10 say [insecret(5,40,8)]
set color to W/n
@ 4,38 to 6,49 double
@ 20,0 say "Enter something secret."
set color to N/W
a = insecret(5,40,8)
set color to W/N
@ 20,0
@ 20,0 say "You typed "+a
stop()

clear
set color to W+/N
@ 5,10 say 'declare t[8]'
@ 6,10 say 't[1] = "FIELD1      C 10"'
@ 7,10 say 't[2] = "FIELD2      N  4 3"'
@ 8,10 say 't[3] = "FIELD3      D  8 0"'
@ 9,10 say 't[4] = "FIELD4      L  1 0"'
@10,10 say 't[5] = "FIELD5      C 10"'
@11,10 say 't[6] = "FIELD6      N  4 3"'
@12,10 say 't[7] = "FIELD7      D  8 0"'
@13,10 say 't[8] = "FIELD8      L  1 0"'
@14,10 say 'makefile( "T", "Erin", 8)'
set color to W/N
@ 20,0 say "Creating file."

declare t[8]
t[1] = "FIELD1      C 10"
t[2] = "FIELD2      N  4 3"
t[3] = "FIELD3      D  8 0"
t[4] = "FIELD4      L  1 0"
t[5] = "FIELD5      C 10"
t[6] = "FIELD6      N  4 3"
t[7] = "FIELD7      D  8 0"
t[8] = "FIELD8      L  1 0"
makefile( "T", "Erin", 8)
@ 20,0 say "File has been created."
stop()

header()
set color to W+/N
@ 5,10 say [maketime("1010")]
@ 7,10 say [maketime("8P")]
@ 9,10 say [maketime("4",600)]
@11,10 say [maketime("4A",600)]
set color to W/N
@ 5,40 say maketime("1010")
@ 7,40 say maketime("8P")
@ 9,40 say maketime("4",600)
@11,40 say maketime("4A",600)
stop()

set color to W+/N
@ 14,10 say [mintostr(400)]
@ 16,10 say [mintostr(1200)]
set color to W/N
@ 14,40 say mintostr(400)
@ 16,40 say mintostr(1200)
stop()

clear
a = 1
set color to W+/N
@ 5,5 say "Executing this function repetitvely:"
@ 7,5 say 'a = option("T",5,60,10,69,"W+/W","W+/W","W/N")'
do while a > 0
	set color to W/N
	@ 12,0 say "Select an option or Esc to quit."
	a = option("T",5,60,10,69,"W+/W","W+/W","W/N")
	set color to W/N
	if a > 0
		@ 10,0 say "You answered with number "+str(a,1)+", which is "+substr(T[a],1,6)+"."
	endif
enddo

header()
set color to W+/N
@ 5,10 say [parsestr(2,"/","A/B/C/D")]
@ 7,10 say [parsestr(1,"/","ABC/B/C/DEF")]
@ 9,10 say [parsestr(6,"/","AB/BC/C/D")]
set color to W/N
@ 5,40 say parsestr(2,"/","A/B/C/D")
@ 7,40 say parsestr(1,"/","ABC/B/C/DEF")
@ 9,40 say parsestr(6,"/","AB/BC/C/D")
stop()

header()
t[1] = "Tracy"
t[2] = "Joel"
t[3] = "Ellen"
t[4] = "Dave"
t[5] = "Jennifer"
t[6] = "Marty"
t[7] = "Sam"
t[8] = "Erin"
set color to W+/N
@ 5,10 say [qsort(3,4,"T")]
set color to W/N
@ 5,40 say "Array before: "
for i = 1 to 8
	@ 6+i,40 say t[i]
next
qsort(3,4,"T")
@ 5,60 say "Array after: "
for i = 1 to 8
	@ 6+i,60 say t[i]
next
stop()

header()
set color to W+/N
@ 5,10 say [qsort(1,8,"T")]
set color to W/N
@ 5,40 say "Array before: "
for i = 1 to 8
	@ 6+i,40 say t[i]
next
qsort(1,8,"T")
@ 5,60 say "Array after: "
for i = 1 to 8
	@ 6+i,60 say t[i]
next
stop()

header()
set color to W+/N
@ 5,10 say [spacefill("ABC",10)+"|"]
@ 7,10 say [spacefill("ABC",1)]
set color to W/N
@ 5,40 say spacefill("ABC",10)+"|"
@ 7,40 say spacefill("ABC",1)
stop()

set color to W+/N
@10,10 say [strtomin("10:00 PM")]
@12,10 say [strtomin(" 8:00 AM")]
set color to W/N
@10,40 say strtomin("10:00 PM")
@12,40 say strtomin(" 8:00 AM")
stop()

set color to W+/N
@15,10 say [zerofill(5,3)]
@17,10 say [zerofill(200,4)]
@19,10 say [zerofill(1234,3)]
set color to W+/N
@15,40 say zerofill(5,3)
@17,40 say zerofill(200,4)
@19,40 say zerofill(1234,3)
stop()

clear
? "That's it!"
?
?

function stop
@ 24,0 say "Press any key to continue or F10 to quit."
if inkey(0) = -9
	clear
	? "You don't know what you're missing!"
	?
	?
	quit
endif
return .f.

function header
clear
@ 3,10 say "Example"
@ 3,40 say "Output"
return .t.

**
**	And they lived happily ever after.  The end!
**
**	Good night Erin.  Daddy loves you.

