* ------------------------------------------------------------------------
* File........:	EXPAND.CH
* Author......:	Pepijn Smits
* Copyright...:	(c)1992, by Softwarebureau Pepijn Smits
* Date........:	August 1992.
* Compiler....:	Clipper 5.01
* Notes.......:	Expand Library standard Header file. 
* ------------------------------------------------------------------------

*		Default values for Parameters
#command	DEFAULT <Param> [TO] <Value>	;
		=>				;
		<Param> := If( <Param> = NIL , <Value> , <Param> )

*		Adapt Statics when parameters have been supplied
#command	ADAPT <Value> [TO] <Param>	;
		=>				;
		<Value> := If( <Param> = NIL , <Value> , <Param> )

*		Alleviate a big frustration for us Dutch.. 
#command	SET DATE [TO] DUTCH		;
		=>				;
		SET DATE FORMAT TO "DD-MM-YYYY"

*		Date Format to the setting from DOS
#command	SET DATE [TO] DOS [COUNTRY]	;
		=>				;
		SET DATE FORMAT TO XPdateFormat()

#define 	K_SPACE		32	// Missing in inkey.ch

#define		CPS30		 0	// Chars/Second for XPkeySpeed()
#define		CPS24		 2
#define		CPS20		 4
#define		CPS15		 8
#define		CPS10		12
#define		CPS8		15
#define		CPS6		18
#define		CPS5		20
#define		CPS4		23
#define		CPS3		26
#define		CPS2		31

