/*****
 *
 *   Application: General Purpose Routine
 *   Description: A "shadow" with "see-thru"      
 *     File Name: SHADOW.PRG
 *        Author: Luiz Quintela
 *  Date created: 12-30-92     
 *     Copyright: 1992 by Computer Associates
 *
 */

FUNCTION Shadow(nTop, nLeft, nBottom, nRight)
   LOCAL nShadowLen, cShadow

   cShadow := SaveScreen( nTop, nLeft, nBottom, nRight )
   nShadowLen := Len(cShadow)

   RestScreen( nTop, nLeft, nBottom, nRight,;
               Transform(cShadow, Replicate("X" + Chr(7), nShadowLen)))
   RETURN (.T.)

// EOF - SHADOW.PRG //
