*******************************************
* test.prg - demo of the floppy_drv() udf *
*******************************************
 PARAMETER drive

 IF TYPE("drive") != "U"
    IF UPPER(drive) = "B"
       drv = 1  && DRIVE B:
     ELSE
       drv = 0  && DRIVE A:
    ENDIF
  ELSE
    drv = 0  && DEFAULT TO A:
 ENDIF

 result = floppy_rdy(drv)  && is disk ready?

 IF result = 0
    ?  'Disk Drive '
    ?? IIF(drv = 0, "A:", "B:")
    ?? ' is ready!'
  ELSE
    DO CASE
       CASE result = 3
          err_msg = "Diskette Is Write-Protected"
       CASE result = 6 .OR. result = 128
          err_msg = "Diskette Drive Door Is Open"
       OTHERWISE
          err_msg = "Diskette Is Unformatted or Wrong Density"
    ENDCASE
    ? err_msg
 ENDIF
