**** WRAP INPUT FUNCTION FOR CLIPPER S87
****
**** (c) Copyright Auto Exec Inc, 1989, ALL RIGHTS RESERVED
**** P.O. Box 1712, Buzzards Bay, MA 02360
**** BBS: Auto Exec BBS (508) 833-0508, 6 Nodes, 1.2 Gigabyte
****      Specializing in Clipper/FoxBase/dBASE/'C'/Pascal
**** Written by Milton F. Shaw Jr.
***********************************************************************
**** Released for Public Domain Distribution as Freeware -
**** No charge can be made for this function without the expressed
**** written consent of Auto Exec Inc.  This function may be distributed
**** by any Bulletin Board System
****
**** WRAPIN
****
**** This function allows you to specify an area on the screen for a
**** wrapped input to be done.  For example you want the input to
**** occur from row 5, column 20 to row 14, column 50 and have a max
**** number of characters entered as 200.  The command would be:
****
****   char=wrapin(5,20,14,50,200)
****        where char will equal the returned string
****
****  The backspace works in the function but not cursor keys for editing
****  As soon as <ENTER> is hit - the function ends returning the string
****  that was entered.
****
****  The function was developed to allow long string inputs that exceed
****  the normal screen width where I can window the area and allow the
****  input to occur, take the input and store it.  The returned character
****  string does NOT have any formatting control character.
****
****  It has been linked using PLINK86 and LINK - have not had success with
****  TLINK.   When I use LINK, I use the command:
****
****  LINK /NOE /SE:250 testwrap,,,clipper+extend+aewrapin
****
****  For Plink:
****
****  PLINK86 FI testwrap LIB clipper,extend,aewrapin
****
****  Any comments are always welcome, leave them on Auto Exec BBS
****
****  Here is a real simple demo of the function.
****
****  The function is a combination of Assembly and 'C' code.
****

clear
char=wrapin(5,10,14,38,200)
@16,1 say char
