/*
  Ŀ
                                                                           
      Program : calendar.PRG                                               
                                                                           
      Purpose : demonstrate the use of HPdrawmonth.                        
                                                                           
     Author  : Copyright (C) 1992, I.L.A.,Inc. All Rights reserved.        
                                                                           
     Comments: This source code may be distributed and used freely         
               provided that the copyright notice is not removed.          
                                                                           
  

*/
#include "prohp.ch"

proc main()
Local nPageH:=7.5 , nPageW:=10 , nCalSp := 0.3
Local nTop := 0, nLeft := 0.2, nCalH := nPageH/2 -nCalSp
Local nDayW,nDayH
Local nCalW:=nPageW, date:=date(), aMo

HP_init()
HP_send(.T.)
set2print("dcalend.hpc")  // send all output to file
HP_orient(LANDSCAPE)
HPshadow(.t.)
HP_data(D_SHADOWWIDTH,HPsetshadow()[1]*1.5) // Look in the manual for answer.
HP_data(D_SHADOWGRAYPAT,30)
HP_setpos(nTop,nLeft)
HP_bar(nCalH,nCalW,GFILLGRAY,2)
HPdrawmonth(date,nTop,nLeft,nCalH,nCalW)

 
nTop+=nCalH+nCalSp
nCalH:=nCalH-1  // leave 1" space down

nCalW:=(nPageW-nCalSp) / 2
date:=zaddmonth(date,-1)
HP_data(D_SHADOWGRAYPAT,20)
HP_data(D_LINEFILL,GFILLGRAY)
HP_data(D_LINEGRAYPAT,40)
nDayW := nCalW / 7
nDayH := nCalH / 6
HP_setpos( nTop+nDayH, nLeft + nDayW * 6)
HP_bar(nCalH-nDayH,nDayW,GFILLGRAY,10)
HPdrawmonth(date,nTop,nLeft,nCalH,nCalW)

nLeft+=nCalW+nCalSp
date:=zaddmonth(date,2)
HP_setpos( nTop+nDayH, nLeft + nDayW * 6)
HP_bar(nCalH-nDayH,nDayW,GFILLGRAY,10)
aMO:=HPdrawmonth(date,nTop,nLeft,nCalH,nCalW)
HP_pitch(16)
HP_lpi(8)

HP_aatsay(aMo[2,1,1]+1/HP_data(D_LPI),aMo[2,1,2]+((aMo[2,2,2]-aMo[2,1,2])/2),;
        {"ProHP","Is","The Best"},,"C")

HP_setpos(aMo[2,1,1],aMo[2,1,2])
HP_bar(aMo[2,8,1]-aMo[2,1,1],aMo[2,2,2]-aMo[2,1,2],GFILLGRAY,10)
nTop+=nCalH+nCalSp
nLeft := 0.2
HP_pitch(10,1)
HP_lpi(6)
HP_aatsay(nTop,nLeft,{[* Create Calendars quickly and easily - Just fill in the parameters.],;
             [* Syntax : ]+HPbold([HPdrawmonth(date,nTop,nLeft,nCalH,nCalW)]),;
             [* Easy to vary size, line type and shading],;
             [* Add text to any box],;
             [* Check out how simple it was to put text in the December calendar, 'DCALENDA.PRG'.]})

HP_reset()      // reset printer to defautls.
set2screen()
return


