* Program..: HLPEXC.PRG
* Author...: RAM
* Date.....: 03/06/88
* Notice...: Copyright (c) 1988, XEC Development, INC., All Rights Reserved.
* Notes....: Programs for exceptions to the Instant Help System Version 2.0

****************************************************************************
*    See exceptions discussion in the Instant Help System Documentation    *
****************************************************************************

****************************************************************************
*   This part of a program checks for the F1 and ALT+H keys to be pressed  *
*   if you are using the inkey() statement to do certain keyboard 	   *
*   processing.  The inkey() instruction is NOT a valid "wait" state in    *
*   Clipper, so if a set key to instruction is being used, F1 and ALT+H    *
*   will NOT function.  So we have to make them function (unless you don't *
*   want them to).							   *
****************************************************************************

    case lastkey() = 28  && Help F1 pressed
       do help with "DLCSMAGET", 723, "INKEY"
        ************************************************************
	*  Send the program name, the line number and the variable *
	*  editing to HELP.PRG.  NOTE:  It doesn't really matter   *
	*  what the program, line and variable are, as long as you *
	*  send the same information with the ALT+H key (see       *
	*  below).						   *
        ************************************************************

    ********************************************************************
    *  NOTE:  Comment out next case statement when finished with       *
    *         INSTAHLP.						       *
    ********************************************************************
    case lastkey() = 291  && ALT-H Pressed.
       do INSTAHLP with "DLCSMAGET", 723, "INKEY"
        ************************************************************
	*  This is the same program, line and variable sent as in  *
	*  the above check on the F1 (key 28) key.  This is very   *
	*  important in that if you don't send matching            *
	*  information (only program and variable matter), the     *
	*  help created with ALT+H will NOT be displayed when F1   *
	*  is pressed.                                             *
        ************************************************************

... your program checking other keys ...


******************************************************************************
*  This next function is for the memoedit command:			     *
*      replace VAR with memoedit(VAR, x1, y1, x2, y2, <.L.>, "DLCSM_EVAL")   *
*  or  VAR = memoedit(VAR, x1, y1, x2, y2, <.L.>, "DLCSM_EVAL")      	     *
*  Put this program in for the function which memoedit calls when it is      *
*  active.                					             *
******************************************************************************

function DLCSM_EVAL  && Evaluate F1 and/or ALT-H (If instahlp is installed).

*****************************************************************************
*   This function will send F1 or ALT-H (if INSTAHLP is installed) to the   *
*   correct program.  The reason for this function is to send the program, *
*   line number, and variable that you want to send, because when an        *
*   interrupt key is pressed in MEMOEDIT, only "MEMOEDIT" is sent to the    *
*   interrupt program.  Line and Variable are NOT sent.  Therefore, you     *
*   must send them yourself, or HELP and INSTAHLP will ignore the call.     *
*****************************************************************************

parameters mode, line, col  && Sent from MEMOEDIT.

if mode = 1 .or. mode = 2  && Sending a keystroke.
   if lastkey() = 28  && Help Key pressed.  Send to HELP.
      do HELP with "DLCSMAGET", 672, "CO_COMM"
        ************************************************************
	*  Send the program name, the line number and the variable *
	*  editing to HELP.PRG.  NOTE:  It doesn't really matter   *
	*  what the program, line and variable are, as long as you *
	*  send the same information with the ALT+H key (see       *
	*  below).						   *
        ************************************************************
      
    **********************************************************************
    *  NOTE:  Comment out (put "*"'s in front of) the next 2 lines of    *
    *         code if instahlp is not installed.                         *
    **********************************************************************
    elseif lastkey() = 291  && ALT-H Pressed.
      do INSTAHLP with "DLCSMAGET", 672, "CO_COMM"
        ************************************************************
	*  This is the same program, line and variable sent as in  *
	*  the above check on the F1 (key 28) key.  This is very   *
	*  important in that if you don't send matching            *
	*  information (only program and variable matter), the     *
	*  help created with ALT+H will NOT be displayed when F1   *
	*  is pressed.                                             *
        ************************************************************
   endif
endif
return 0  && Prosess last key pressed.
