/*Ŀ
 ݳ                                                                      
 ݳ Program Name: NC3.PRG           Copyright: Gallagher Computing Corp. 
 ݳ Date Created: 10/13/92           Language: Clipper 5.0               
 ݳ Time Created: 20:28:51             Author: Kevin S Gallagher         
 ݳ Libraries   : nanfor.lib, grump.lib -- grump.lib is optional         
 ݳ Purpose     : To alter colors of The Norton Commander Ver. 3         
 ݳ Compile     : /m/n/l                                                 
 ݳ Link(er)    : Rtlink/Warplink/Blinker                                
 ݳ Notes       : The Array NCARR is for restoring NC's original colors! 
 
            */
#include "norton.ch"
static NCARR:={ "1B", "30", "1E", "3E",      ;      // Panels, Edit:       
                "07", "30", "00", "00",      ;      // Function Key Bar:   
                "70", "30", "7E", "3E",      ;      // Dialog Boxes:       
                "4F", "70", "4E", "7F",      ;      // Alert Boxes:        
                "30", "0F", "3F", "3E",      ;      // Help Box:           
                "3F", "07", "3E", "3A",      ;      // User Menu Edit Help:
                "3F", "0F", "3E", "3A",      ;      // User Menu, History: 
                "30", "0F", "00", "00",      ;      // Menu Bar:           
                "30", "0F", "0E", "3F",      ;      // Pull Down Menus:    
                "3F", "0F", "3E", "0E"       }      // NCD, FF, Config:    
static xClrs,mm,oo,gg,hh,aArry:={}                  // Silly vars Huh!

function main
    local oldcolor:=setcolor("w+/n,w+/bg"), nSelect:=0
    local Menu_:={ "Restore colors", "Change colors", "Quit to DOS" }
    *************************************************************************
    * This is for showing program options... *
    *************************************************************************
    set(_SET_SCOREBOARD,.F.)
    setcursor(0)
    scroll()
    @maxrow(),0 say PADC(KSG_ABOUT,80) color "N/BG"
    dispbox(3,30,7,47,B_DOUBLE+" ")
    WHILE .T.
        ReadNC()
        nSelect:=achoice(4,31,6,46,Menu_)
        if nSelect = 0 .or. nSelect = 3   ;  quitbox(oldcolor)
        endif
        do case
            case nSelect = 1              ;  NCrestore(.T.)
            case nSelect = 2              ;  AlterNC()
        endcase
    ENDDO
return nil

function ReadNC
    local cBuf:=space(FBLOCK), nHandle:=0, WB:="W+/B"
    local nRow:=9, nCol:=33, nBc:=13, xx, x
    *************************************************************************
    * Open ncmain.exe and get current colors *
    *************************************************************************
    if LEN(aArry) > 1
        aArry:={}
    endif
    nHandle = FOPEN("ncmain.exe", FO_READWRITE)
    IF FERROR() != 0
        Devpos(0,0)    ;DevOut("Error opening file code -> ","w+ /r")
        DevPos(0,col());DevOut(ltrim(str(FERROR())),         "gr+/r")
        BREAK
    ENDIF
    FSEEK(nHandle, BEGIN_ADDRESS)
    FREAD(nHandle, @cBuf, FBLOCK)
    FCLOSE(nHandle)
    for x = 1 to 40
        AADD(aArry,strtran(FT_BYT2HEX(substr(cBuf,x,1)),"h"," "))
    next
    dispbox(nRow-1,nCol-2,nRow+10,nBc+nCol,B_DOUBLE+" ",WB)
    x:=0
    for xx = 1 to 10
        @nRow,nCol say aArry[++x]+aArry[++x]+aArry[++x]+aArry[++x] color WB
        nRow++
    next
return nil

function AlterNC
    local SaveFullScreen(), getlist:={}, nRow:=1, nCol:=2, nGet:=18, nHandle
    local oldcolor:=setcolor("gr+/b,w+/n"), FreshArry_:={}, nSelect, x
    *************************************************************************
    * Open ncmain.exe and change the colors *
    *************************************************************************
    dispbox(0,0,maxrow(),maxcol(),B_SINGLE+" ","W/B")
    #ifdef MRGRUMP
       set key K_F2 to ChkColor(p,l,v)
       @0,5 say "[F2=Color help  Enter Hex values]"        color "w/b"
    #else
       @0,5 say "[Color selection Enter Hex values]"       color "w/b"
    #endif
    FreshArry_:=ACLONE(aArry)
    @  nRow,nCol say "Panel/Edit colors"                   color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get PANEL_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get PANEL_INVERSE           
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get PANEL_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get PANEL_INV_BRITE
    @++nRow,0    say ""
    @++nRow,nCol say "Function Key colors"                 color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get FUNCKY_BAR_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get FUNCKY_BAR_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get FUNCKY_BAR_BRIGHT 
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get FUNCKY_BAR_INV_BRITE
    @++nRow,0    say ""
    @++nRow,nCol say "Dialog Boxes colors"                 color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get DIALOG_BOX_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get DIALOG_BOX_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get DIALOG_BOX_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get DIALOG_BOX_INV_BRITE
    @++nRow,0    say ""
    @++nRow,nCol say "Alert Boxes colors"                  color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get ALERT_BOX_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get ALERT_BOX_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get ALERT_BOX_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get ALERT_BOX_INV_BRITE
    @++nRow,0    say ""
    nRow:=1
    nCol:=24
    nGet:=40
    @  nRow,nCol say "Help Box colors"                     color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get HELP_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get HELP_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get HELP_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get HELP_INV_BRITE
    nRow+=1
    @++nRow,nCol say "User Menu Edit Help colors"          color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get USER_ED_HLP_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get USER_ED_HLP_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get USER_ED_HLP_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get USER_ED_HLP_INV_BRITE
    nRow+=1
    @++nRow,nCol say "User Menu, History colors"           color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get USER_MENU_HIST_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get USER_MENU_HIST_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get USER_MENU_HIST_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get USER_MENU_HIST_INV_BRITE
    nRow+=1
    @++nRow,nCol say "Menu Bar colors"                     color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get MENU_BAR_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get MENU_BAR_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get MENU_BAR_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get MENU_BAR_INV_BRITE
    nRow:=1
    nCol:=54
    nGet:=74
    @  nRow,nCol say "Pull Down Menus colors"              color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get PDOWN_MENU_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get PDOWN_MENU_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get PDOWN_MENU_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get PDOWN_MENU_INV_BRITE
    nRow+=2
    @  nRow,nCol say "NCD, FF, Config colors"              color "bg+/b"
    @++nRow,nCol say SAY_NORMAL
    @  nRow,nGet get NCD_FF_INI_NORMAL
    @++nRow,nCol say SAY_INVERSE
    @  nRow,nGet get NCD_FF_INI_INVERSE
    @++nRow,nCol say SAY_BRIGHT
    @  nRow,nGet get NCD_FF_INI_BRIGHT
    @++nRow,nCol say SAY_INVERSE_BRIGHT
    @  nRow,nGet get NCD_FF_INI_INV_BRITE
    setcursor(1)
    read
    nSelect:=alert("WRITE NEW COLORS",{" NO "," YES "})
    IF nSelect = 0 .or. nSelect = 1
        ALERT("Operation aborted!")
    ELSE
        AEVAL(FreshArry_,{|a,b| FreshArry_[b] :=SUBS(a,1,2)})
        nHandle = FOPEN("ncmain.exe", FO_READWRITE)
        IF FERROR() != 0
            Devpos(0,0)    ;DevOut("Error opening file code -> ","w+ /r")
            DevPos(0,col());DevOut( LSTRINT( FERROR() ),         "gr+/r")
            QUIT
        ENDIF
        FSEEK(nHandle,BEGIN_ADDRESS)
        for x = 1 to 40
            FWRITE(nHandle,FIXMEUP(FreshArry_[x]))
        next
        FCLOSE(nHandle)
    ENDIF
    set key K_F2 to
    setcolor(oldcolor)
    RestFullScreen()
return nil

function NCrestore( lMode )
    local x, nHandle
    *************************************************************************
    * Function to restore original factory colors *
    *************************************************************************
    nHandle = FOPEN("ncmain.exe", FO_READWRITE)
    IF FERROR() != 0
        Devpos(0,0)     ; DevOut("Error opening file code -> ","w+ /r")
        DevPos(0,col()) ; DevOut( LSTRINT( FERROR() ),         "gr+/r")
        QUIT
    ENDIF
    FSEEK(nHandle,BEGIN_ADDRESS)
    for x = 1 to 40
        FWRITE(nHandle,FIXMEUP(NCARR[x]))
    next
    FCLOSE(nHandle)
return nil


#ifdef MRGRUMP
function ChkColor
    local oldcolor:=setcolor(), GetCurr
    *************************************************************************
    * Uses GetSystem to work on current GET  *
    *************************************************************************
    set key K_F2 to
    GetCurr:= GetActive():VarGet()
    xClrs = COLORPAL(SETCOLOR(), 6, 60, 'redraw()')
    mm:=color_s2n(xClrs)
    hh:=Ltrim(FT_BYT2HEX(CHR(mm)))
    setcolor(oldcolor)
    if lastkey() = K_ESC
        GetActive():VarPut(GetCurr)
    else
        GetActive():VarPut(hh)
    endif
    set key K_F2 to ChkColor(p,l,v)
return nil
FUNCTION redraw
    dispbox(0,0,5,10,B_DOUBLE+" ")
RETURN nil
#endif

function quitbox(oldcolor)                          // return to DOS
    setcolor(oldcolor)
    scroll()
    DevPos(0,0)
    DevOut(PADR(KSG_ABOUT,80),"bg+/b")
    quit
return nil

#ifdef PRGHELP
function HELP
    local SaveFullScreen(),nRow:=1, nCol:=4, oldcursor:=setcursor(0)
    scroll()
    DevPos(0,0);DevOut( PADC("PRESS ANY KEY TO EXIT HELP",80),"w+/b" )
    @  nRow,nCol say "Main menu options:"
    @++nRow,nCol say "Restore colors option is used to restore Norton Commanders original colors"
    @++nRow,nCol say "prior to any color changes with this utility."
    @++nRow,nCol say ""
    @++nRow,nCol say "Change colors option is used to alter the colors of The Norton Commander."
    @++nRow,nCol say "Enter the color in Hex format not decimal!  If an error is made,  you can"
    @++nRow,nCol say "use the main menu option one to restore the original colors.."
    @++nRow,nCol say "An added option has been added for those who own 'grump.lib' which allows"
    @++nRow,nCol say "you to press the function key F2 for visual color selections. Press ENTER"
    @++nRow,nCol say "on the color you want for the current color and the Hex value is inserted"
    @++nRow,nCol say "into the GET (pressing {ESC} aborts insertion of new color)."
    @++nRow,nCol say "Once the colors choices have been  made, an alert box will ask permission"
    @++nRow,nCol say "to write new colors to  'ncmain.exe' or to abort/return to the main menu."
    @++nRow,nCol say ""
    @++nRow,nCol say "The last main menu option is used to exit to MS-DOS"
    @++nRow,nCol say ""
    @++nRow,nCol say ""
    @++nRow,nCol say "Prior to using this utility, make a backup copy of ncmain.exe"
    @++nRow,nCol say ""
    @++nRow,nCol say "The Norton Commander color utility created by Kevin S. Gallagher"
    @++nRow,nCol say ""
    @++nRow,nCol say "The Norton Commander is a product/copyright to Symantec, inc."
    inkey(0)
    RestFullScreen()
    setcursor(oldcursor)
return nil
#endif
