/*Ŀ
 ݳ                                                                      
 ݳ Program Name: NORTON.CH         Copyright: Gallagher Computing Corp. 
 ݳ Date Created: 10/13/92           Language: Clipper 5.0               
 ݳ Time Created: 23:54:50             Author: Kevin S Gallagher         
 ݳ c:/brief/clipper.src                                                 
 
            */

#include "fileio.ch"
#include "inkey.ch"
#include "box.ch"
// nanfor.lib include file
#include "ftint86.ch"

// uncomment if you own GRUMP.LIB
// #define MRGRUMP
// uncomment to enable help
// #define PRGHELP

#ifdef MRGRUMP
   //
   // Clipper will use only if MRGRUMP is defined
   //
   #include 'grump.ch'
#endif

// used for get data from ncmain.exe
#define FBLOCK              400

// used by FSEEK()
#define BEGIN_ADDRESS    127534
#define END_ADDRESS      127573


#define SaveFullScreen()	cFullScreen := SAVESCREEN( 0, 0, 24, 79 )
#define RestFullScreen()	RESTSCREEN( 0, 0, 24, 79, cFullScreen )

//  used for altering colors function
#define SAY_NORMAL                 "Normal         "
#define SAY_INVERSE                "Inverse        "
#define SAY_BRIGHT                 "Bright         "
#define SAY_INVERSE_BRIGHT         "Inverse/Bright "

#define PANEL_NORMAL                FreshArry_[ 1]
#define PANEL_INVERSE               FreshArry_[ 2]
#define PANEL_BRIGHT                FreshArry_[ 3]
#define PANEL_INV_BRITE             FreshArry_[ 4]

#define FUNCKY_BAR_NORMAL           FreshArry_[ 5]
#define FUNCKY_BAR_INVERSE          FreshArry_[ 6]
#define FUNCKY_BAR_BRIGHT           FreshArry_[ 7]
#define FUNCKY_BAR_INV_BRITE        FreshArry_[ 8]

#define DIALOG_BOX_NORMAL           FreshArry_[ 9]
#define DIALOG_BOX_INVERSE          FreshArry_[10]
#define DIALOG_BOX_BRIGHT           FreshArry_[11]
#define DIALOG_BOX_INV_BRITE        FreshArry_[12]

#define ALERT_BOX_NORMAL            FreshArry_[13]
#define ALERT_BOX_INVERSE           FreshArry_[14]
#define ALERT_BOX_BRIGHT            FreshArry_[15]
#define ALERT_BOX_INV_BRITE         FreshArry_[16]

#define HELP_NORMAL                 FreshArry_[17]
#define HELP_INVERSE                FreshArry_[18]
#define HELP_BRIGHT                 FreshArry_[19]
#define HELP_INV_BRITE              FreshArry_[20]

#define USER_ED_HLP_NORMAL          FreshArry_[21]
#define USER_ED_HLP_INVERSE         FreshArry_[22]
#define USER_ED_HLP_BRIGHT          FreshArry_[23]
#define USER_ED_HLP_INV_BRITE       FreshArry_[24]

#define USER_MENU_HIST_NORMAL       FreshArry_[25]
#define USER_MENU_HIST_INVERSE      FreshArry_[26]
#define USER_MENU_HIST_BRIGHT       FreshArry_[27]
#define USER_MENU_HIST_INV_BRITE    FreshArry_[28]

#define MENU_BAR_NORMAL             FreshArry_[29]
#define MENU_BAR_INVERSE            FreshArry_[30]
#define MENU_BAR_BRIGHT             FreshArry_[31]
#define MENU_BAR_INV_BRITE          FreshArry_[32]

#define PDOWN_MENU_NORMAL           FreshArry_[33]
#define PDOWN_MENU_INVERSE          FreshArry_[34]
#define PDOWN_MENU_BRIGHT           FreshArry_[35]
#define PDOWN_MENU_INV_BRITE        FreshArry_[36]

#define NCD_FF_INI_NORMAL           FreshArry_[37]
#define NCD_FF_INI_INVERSE          FreshArry_[38]
#define NCD_FF_INI_BRIGHT           FreshArry_[39]
#define NCD_FF_INI_INV_BRITE        FreshArry_[40]

// Does what it says
#xtranslate  LSTRINT( <f> )   => LTRIM(STR(INT( <f> ) ) )
// used to write data back to ncmain.exe
#xtranslate  FIXMEUP( <f> )   => CHR( FT_HEX2DEC( <f> ) )

#command  DEFAULT <p> TO <val> [,<pn> TO <valn>] ;
                  =>  <p> = iif(<p>  = NIL, <val>,  <p>) ;
                  [;<pn>  = iff(<pn> = NIL, <valn>, <pn>)]

#ifdef JJUNK
// Put this into the program file to test it out - magenta color scheme
static NEWNC:={ "5F", "30", "5E", "3E",  ;   // Panels, Edit:
                "07", "30", "00", "00",  ;   // Function Key Bar:   
                "70", "1F", "7E", "1E",  ;   // Dialog Boxes:       
                "4F", "70", "4E", "7F",  ;   // Alert Boxes:        
                "30", "0F", "3F", "3E",  ;   // Help Box:           
                "1F", "07", "1E", "1A",  ;   // User Menu Edit Help:
                "1F", "0F", "1E", "1A",  ;   // User Menu, History: 
                "30", "0F", "00", "00",  ;   // Menu Bar:           
                "30", "0F", "0E", "3F",  ;   // Pull Down Menus:    
                "1F", "0F", "1E", "0E"   }   // NCD, FF, Config:    

// original Norton Colors
****************************************************************************
*                     Normal                                               *
*                    /     Inverse                                         *
*                   /     /     Bright                                     *
*                  /     /     /     Inverse Bright                        *
****************  /     /     /     / **************************************
static NCARR:={ "1B", "30", "1E", "3E",  ;   // Panels, Edit:       
                "07", "30", "00", "00",  ;   // Function Key Bar:   
                "70", "30", "7E", "3E",  ;   // Dialog Boxes:       
                "4F", "70", "4E", "7F",  ;   // Alert Boxes:        
                "30", "0F", "3F", "3E",  ;   // Help Box:           
                "3F", "07", "3E", "3A",  ;   // User Menu Edit Help:
                "3F", "0F", "3E", "3A",  ;   // User Menu, History: 
                "30", "0F", "00", "00",  ;   // Menu Bar:           
                "30", "0F", "0E", "3F",  ;   // Pull Down Menus:    
                "3F", "0F", "3E", "0E"   }   // NCD, FF, Config:    
#endif

// echos message to display screen
#define KSG_ABOUT " The Norton Commander color utility by Kevin S. Gallagher"
