* sdemo.prg 05/09/89 11:25pm
* demonstration clipper-code program to show demo version of SEZ_YOU!
* (c) 1989 SoundView Data Systems / all rights reserved

* link with getdemo.obj and use clipper.lib and extend.lib

set color to w+/b
clear
set confirm off
set scoreboard off
set cursor off
@ 4,10,20,70 box "Ŀ "
@ 6,11 say ""
set color to g+/b
@ 5,27 say " SEZ_YOU! DEMONSTRATION "
set color to b/w

*---screen1
@ 7,11 clear to 19,69
scrlup("This short Clipper-compiled program will demonstrate")
scrlup("the ability of SEZ_YOU! to alter the internal default")
scrlup("values of the environmental parameters as well as the")
scrlup("implantation and retrieval of a hidden identification")
scrlup("string in the target .exe file.")
scrlup("")
scrlup("The DEMONSTRATION version of SEZ_YOU! (...says Who?)")
scrlup('is limited to modification of the "X" and "R" values')
scrlup("only, and the identification-code (if requested) is ")
scrlup('hard-coded for "DEMO_01" regardless of the code')
scrlup('specified on the command line as the "I" parameter.')
getkey()

*---screen2
scrlup("")
scrlup("")
scrlup("")
scrlup("Please wait, while excess available memory is used")
scrlup("up, to simulate a real application:")
scrlup("")
scrlup("")
scrlup("")
scrlup("")
scrlup("")
scrlup("")
scrlup("")
declare memHog[200]
i = 1
       do while ( memory( 0 ) > 8 .and. i < 200 )
               memHog[i] = space(4000)
               i = i + 1
               @ 13,32 say replicate(".",mod(i,18)) + space(17)
       enddo
getkey()

*---screen3
@ 8,13 clear to 18,67
scrlup("We will now try to demonstrate modifying the R and")
scrlup("X parameters. First determine the minimum values")
scrlup("that permit RUNning this demo program, by trying")
scrlup("different values in a SET CLIPPER= statement. Then")
scrlup("use SEZ_YOU! to preset the same R or X values in")
scrlup("this (SDEMO.EXE) file, using the command:")
scrlup("")
scrlup("   SYDEMO SDEMO.EXE Rxxx [Xxxx] [Iserial_#]")
scrlup("")
scrlup('Remember to first issue a "SET CLIPPER=" to prevent ')
scrlup("the new internal defaults from being overridden.")
getkey()

*---screen4
@ 8,13 clear to 18,67
scrlup("At the next keypress, this demonstration program")
scrlup("will try to RUN SEZ_YOU!. This will require about")
scrlup("35K of free memory for the program and its buffers.")
scrlup("")
scrlup('Try using SEZ_YOU! on this demonstration .exe file,')
scrlup("to see that the internal patches behave in the same")
scrlup("manner as a SET CLIPPER= environmental would. Too ")
scrlup("small an R-value will prevent RUNning this program.")
scrlup("")
scrlup("Press any key now, to RUN SEZ_YOU!...")
scrlup("")
getkey()
scrnmem = savescreen(0,0,24,79)
set color to w/n
clear
! sydemo
set color to w+/n
? " Press any key to continue "
inkey(0)
restscreen(0,0,24,79,scrnmem)
set color to b/w

*---screen5
@ 8,13 clear to 18,67
scrlup("This demonstration program has been functioning")
scrlup("with the following environmental values (loaded by")
scrlup("default, by SEZ_YOU!, or from the environment).")
scrlup("")
scrlup("V =                       Identification code:")
scrlup("R =       -1 = true 0  ")
scrlup("E =       0 = default  ")
scrlup("X =                       Environmental string:")
scrlup("F =                     ")
scrlup("S =                     ")
scrlup("(The demo version only returns the X and R values.)")

*@ 12,20 say ltrim(str(getenv("v")))
@ 13,20 say ltrim(str(getenv("r")))
*@ 14,20 say ltrim(str(getenv("e")))
@ 15,20 say ltrim(str(getenv("x")))
*@ 16,20 say ltrim(str(getenv("f")))
*@ 17,20 say ltrim(str(getenv("s")))
@ 13,48 say get_id()
@ 16,48 say get_ename()
getkey()

*---screen6
@ 8,14 clear to 18,66
scrlup("Of course, the full version of SEZ_YOU! can also")
scrlup("alter the V,E,F and S variables, and allows you to")
scrlup("specify the identification code and the name of the")
scrlup("environmental SET string.")
scrlup("")
scrlup("Additionally, functions are supplied that can")
scrlup("retrieve the environmental values and string name for")
scrlup("testing and error-routines, and the identification")
scrlup("code for display on title screens and reports. (The")
scrlup('demo can only implant the code "DEMO_01", however.)')
scrlup("")
getkey()

*---screen7
@ 8,14 clear to 18,66
scrlup("SEZ_YOU! costs $49.00 (plus $5.00 S/H) and has a")
scrlup("30 day money-back guarantee if it fails to perform")
scrlup("as described. It is available from:")
scrlup("")
set color to r/w
scrlup("            PROGRAMMING SOLUTIONS")
scrlup("            5320 South 900 East, Suite 100")
scrlup("            Salt Lake City, Utah  84117")
scrlup("            801/262-4141 (voice)")
set color to b/w
scrlup("")
scrlup("     Support is by mail, telephone, and Email")
scrlup("")
@ 23,0 say ""
set cursor on
set color to
quit

*******************************
* Function: scrlup()
* Notes: for sdemo.prg
*        scrolls up window after brief delay, then prints text at bottom line
function scrlup
para mtext

for delay = 1 to 70
next
scroll(8,11,18,69,1)    && roll it up one
@ 18,14 say mtext
return ""

*******************************
* Function: getkey()
* Notes: for sdemo.prg
*        waits for inkey(0), prints and clears prompt
function getkey

set color to w+/b
@20,27 say " Press any key to continue "
inkey(0)
@20,27 say ""
set color to b/w
return ""




*eof sdemo.prg


