***************************************************************************
* Demonstrate QUEUE.BIN (OBJ)
* 10/1/87
* Notice that very little error checking is done -- you can use one function
* to verify whether another was successful (with the exception of verifying
* multiple submit requests on the same file), but I didn't [grin]
***************************************************************************
SET STAT OFF
SET BELL OFF
SET TALK OFF
SET SCOR OFF
PUBLIC CLIPPER
IF .NOT. CLIPPER
      LOAD Queue
ENDI
SET COLOR TO +W/GR,W+/B,B
CLEAR
@ 00,02 SAY ""
@ 01,01 SAY "                                   "
@ 02,02 SAY "                                  "
@ 03,05 SAY "                             "
@ 04,01 SAY "  YNERGY                         "
@ 05,08 SAY "Presents: Ŀ                     (.BIN & OBJ)"
@ 06,20 SAY "    "+space(32)+""
@ 07,20 SAY ""
@ 22,22 SAY "       Your choice:               "
@ 23,22 SAY ""
SET COLOR TO +W/BG
@ 09,17 TO 21,62 DOUBLE
@ 21,22 SAY ""
@ 21,57 SAY ""
SET COLOR TO +W/B
@ 10,18 CLEAR TO 20,61
@ 11,22 SAY "1) Submit a file to the PRINT queue"
@ 12,22 SAY "2) Cancel file(s) from the queue"
@ 13,22 SAY "3) Cancel all files"
@ 14,22 SAY "4) Pause background printing"
@ 15,22 SAY "5) Resume background printing"
@ 16,22 SAY "6) Find name of file being printed"
@ 17,22 SAY "7) Get printer/queue status"
@ 18,22 SAY "8) Check for file name in queue"
@ 19,22 SAY "9) Exit this program"
SET COLOR TO +W/GR,G+/N,B
mparam = "0"
CALL Queue WITH mparam
nul=' '
DO CASE
CASE ASC(mparam)=1
      @24,0 SAY ;
      "You cannot use this program without DOS 3.x or better...press any key"
      * note that this error can occur with any function
      @23,0 SAY nul
      WAIT ''
      READ
      RETU
CASE ASC(mparam)=32
      @24,0 SAY ;
      "Queue not installed, QUIT dBASE and load PRINT.COM if you wish...press any key"
      @23,0 SAY nul
      WAIT ''
      RETU
CASE ASC(mparam)=33
      @24,0 SAY ;
      "Print queue is not installed, conflict detected...press any key"
      @23,0 SAY nul
      WAIT ''
      RETU
ENDC

choice = 0

DO WHIL choice < 9
      choice = 0
      @ 22,44 GET choice PICTURE "9" RANGE 1,9
      READ
      @24,0 SAY SPAC(80)
      DO CASE
      CASE choice = 1
            mfname=SPAC(64)
            @24,0 SAY "File to submit:" GET mfname
            READ
            mparam="1 "+LTRIM(TRIM(mfname))
            CALL Queue WITH mparam
      CASE choice = 2
            mfname=SPAC(64)
            @24,0 SAY "Filespec to cancel:" GET mfname PICT "@S55"
            READ
            mparam="2 "+LTRIM(TRIM(mfname))
            CALL Queue WITH mparam
      CASE choice = 3
            CALL Queue WITH "3"
      CASE choice = 4
            CALL Queue WITH "4"
            @24,0 SAY "Printing paused"
      CASE choice = 5
            CALL Queue WITH "5"
            @24,0 SAY "Printing restarted"
      CASE choice = 6
            mparam = "6" + SPAC(63) && maximum length is 64 bytes, make room or
                                    && otherwise you may trash other memvars
            CALL QUEUE WITH mparam  && the current file's name is copied in...
            IF LEFT(mparam,1)="-"   && error return for this call is "-"
                  @24,0 SAY "No files in cue"
            ELSE
                  @24,0 SAY "Printing file: " + TRIM(mparam)
            ENDIF
      CASE choice = 7
            mparam = "7"
            CALL QUEUE WITH mparam
            IF mparam="0"
                  @24,0 SAY "No errors detected"
            ELSE
                  @24,0 SAY ;
                  "Errors on list device indicate that it may be offline"
            ENDIF
      CASE choice = 8
            mfname=SPAC(64)
            @24,0 SAY "File to check:" GET mfname
            READ
            mparam="8 "+LTRIM(TRIM(mfname))
            CALL Queue WITH mparam
            @24,0 SAY SPAC(80)
            IF SUBS(mparam,1,1)="0"
                  @24,0 SAY "That file is not in the queue"
            ELSE
                  @24,0 SAY "Verified--file is in queue"
            ENDIF
      ENDC
ENDD
CLEA
RETU
