/*
** FILE: Yourprog.c
**
** Example of linking ez_help into your application
**
** These files are linked into Yourprog:
**    ez_help, ezhelp1, ezhelp2
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <mem.h>
#include <dos.h>
#include "ezhelp.h"

/* 1. include ezhelp.h in your program */

static ezhelp_env env;

/* 2. Place the above declaration at the top of your program    */
/*    or in the routine that calls ez_help.                     */

main() {

  char myfile[21] = { "d:\\help\\ezhelp.txt " };
  myfile[20] = 0;
  memset(&env,0,(long)sizeof(ezhelp_env));


/* 3. Place the reference file name in env.ref_file */

  strcat(&env.ref_file[0],&myfile[0]);

/* 4. Fill options into env fields. */

  env.bar_colo    = 79;   /* bar color */
  env.win_colo    = 31;   /* window color */
  env.window_size = 18;   /* size of window 5 - 23 */

/* 5. Env.start_menu and env.show_errors are required. */

  env.start_menu  = 1;    /* startup menu number */
  env.show_errors = 0;    /* 1 = display errors */

/* 6. Call ez_help with the address of env. */

  ez_help(&env);

}
